;Disp86i - modified unbloat (no abs addr, alternate offset size)

;d86isub - for use as an asm subroutine

;08-23-00 - changed for 1-8 bit offsets instead of 8-15
;08-14-00 - fixed 16k bug
;03-25-00



;               UNBLOAT by SCaBBy       13/2/98
;               Z80 LZSS Implementation   v0.92

;modified & commented by joshua seagoe 3-23-00


; hl = source
; de = dest

d86i:
Disp86i:
        ld c,(hl)           ; load size word
        inc hl
        ld b,(hl)
        inc hl
;        dec bc              ; unbloat wants it smaller
        inc bc
        push bc
        pop ix              ; size in ix

;abs version removed
;load var space to (5) and (6)
;decompress to ram page 0 only
Unbloat:
        ld a,(hl)           ;read databits (bits per byte)-1
        and 7
        inc a
        ld (DataBits),a
        ld a,(hl)
        rrca
        rrca
        rrca
        push af             ;get lenbits (match length)-2
        and 3
        add a,2
        ld (LenBits),a
        pop af
        rrca                ;get posbits (match offset)-1
        rrca
        and 7
        inc a               ;1-8
        ld (PosBits),a
        inc hl
        ld (AbortSP),sp     ;save stack
        ld b,1
DecodeLoop:
        call GetBit         ;get one bit from input stream to carry
        jr nc,DecodeLZString
        ld a,8              ;read literal byte
DataBits =$-1
        call GetBits        ;read a bits from stream to a
        ld (de),a           ;write literal byte
        inc de
        jr DecodeLoop
DecodeLZString:             ;read compressed data
        push de             ;save dest
        ld a,-1             ;make it negative
        ld d,4              ;read pos data high byte
PosBits =$-1
        call DoGetBits      ;read d bits from stream to a
        ld d,-1
        ld e,a
        ld a,3              ;read len data
LenBits =$-1
        call GetBits        ;read a bits from stream to a
        add a,2             ; (fixed 8-20-00 for NewEncode)
        ex (sp),hl          ;get dest ptr & save source
        ex de,hl            ;swap so dest is saved
        add hl,de           ;hl->source in dest to copy
        push bc
        ld b,0              ;length of data to copy
        ld c,a
        ldir                ;copy from decompressed data
        pop bc
        pop hl              ;get source
        jr DecodeLoop


;read a bits from stream to a
GetBits:
        push de
        ld d,a
        xor a
        call DoGetBits      ;read d bits from stream to a
        pop de
        ret

;read d bits from stream to a
DoGetBits:
        inc d
BitFetch:
        dec d
        ret z
        call GetBit         ;get a bit
        rla                 ;add it to a at bottom
        jr BitFetch

;get one bit from input stream to carry
;b=bits left in byte+1
;c=byte from stream
;ix=bytes left in stream
;hl->data stream
;a,de preserved
;carry is bit read
GetBit:
        djnz NotNextByte    ;if there's a bit left, get it
        ld b,a
        ld a,ixl             ;any bytes left in stream?
        or ixh
        jr nz,NotAbort      ;yes->
        ld sp,1234h         ;ret will now exit from UnBloat
AbortSP =$-2
NotAbort:
        ld c,(hl)           ;read next byte
        inc hl
        dec ix
        ld a,b
        ld b,8              ;8 bits in byte
NotNextByte:
        rr c                ;take bit out of byte
        ret




